/* Application.c generated by valac 0.56.14, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2011-2016 Felipe Escoto (https://github.com/Philip-Scott/Notes-up)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
* Authored by: Felipe Escoto <felescoto95@hotmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define ENOTES_APPLICATION_PROGRAM_NAME N_ ("Notes-Up")
#define ENOTES_APPLICATION_COMMENT N_ ("Your Markdown Notebook.")
#define ENOTES_APPLICATION_ABOUT_STOCK N_ ("About Notes")
#define TERMINAL_NAME "notes-up"
#define CONSTANTS_VERSION "1.3"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	ENOTES_KEY_CHANGE_MODE,
	ENOTES_KEY_SAVE,
	ENOTES_KEY_QUIT,
	ENOTES_KEY_NEW_PAGE,
	ENOTES_KEY_FIND,
	ENOTES_KEY_BOOKMARK,
	ENOTES_KEY_BOLD,
	ENOTES_KEY_ITALICS,
	ENOTES_KEY_STRIKE
} ENotesKey;

#define ENOTES_TYPE_KEY (enotes_key_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define ENOTES_SERVICES_TYPE_SETTINGS (enotes_services_settings_get_type ())
#define ENOTES_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettings))
#define ENOTES_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettingsClass))
#define ENOTES_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_SERVICES_TYPE_SETTINGS))
#define ENOTES_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_SERVICES_TYPE_SETTINGS))
#define ENOTES_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettingsClass))

typedef struct _ENotesServicesSettings ENotesServicesSettings;
typedef struct _ENotesServicesSettingsClass ENotesServicesSettingsClass;

#define ENOTES_TYPE_WINDOW (enotes_window_get_type ())
#define ENOTES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_WINDOW, ENotesWindow))
#define ENOTES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_WINDOW, ENotesWindowClass))
#define ENOTES_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_WINDOW))
#define ENOTES_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_WINDOW))
#define ENOTES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_WINDOW, ENotesWindowClass))

typedef struct _ENotesWindow ENotesWindow;
typedef struct _ENotesWindowClass ENotesWindowClass;

#define ENOTES_TYPE_APPLICATION (enotes_application_get_type ())
#define ENOTES_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_APPLICATION, ENotesApplication))
#define ENOTES_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_APPLICATION, ENotesApplicationClass))
#define ENOTES_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_APPLICATION))
#define ENOTES_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_APPLICATION))
#define ENOTES_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_APPLICATION, ENotesApplicationClass))

typedef struct _ENotesApplication ENotesApplication;
typedef struct _ENotesApplicationClass ENotesApplicationClass;
typedef struct _ENotesApplicationPrivate ENotesApplicationPrivate;
enum  {
	ENOTES_APPLICATION_0_PROPERTY,
	ENOTES_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* enotes_application_properties[ENOTES_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define ENOTES_TYPE_NOTEBOOK_TABLE (enotes_notebook_table_get_type ())
#define ENOTES_NOTEBOOK_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTable))
#define ENOTES_NOTEBOOK_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTableClass))
#define ENOTES_IS_NOTEBOOK_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_NOTEBOOK_TABLE))
#define ENOTES_IS_NOTEBOOK_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_NOTEBOOK_TABLE))
#define ENOTES_NOTEBOOK_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTableClass))

typedef struct _ENotesNotebookTable ENotesNotebookTable;
typedef struct _ENotesNotebookTableClass ENotesNotebookTableClass;

#define ENOTES_TYPE_NOTEBOOK (enotes_notebook_get_type ())
#define ENOTES_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_NOTEBOOK, ENotesNotebook))
#define ENOTES_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_NOTEBOOK, ENotesNotebookClass))
#define ENOTES_IS_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_NOTEBOOK))
#define ENOTES_IS_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_NOTEBOOK))
#define ENOTES_NOTEBOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_NOTEBOOK, ENotesNotebookClass))

typedef struct _ENotesNotebook ENotesNotebook;
typedef struct _ENotesNotebookClass ENotesNotebookClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

struct _ENotesApplication {
	GraniteApplication parent_instance;
	ENotesApplicationPrivate * priv;
	gboolean running;
};

struct _ENotesApplicationClass {
	GraniteApplicationClass parent_class;
};

VALA_EXTERN ENotesServicesSettings* enotes_settings;
ENotesServicesSettings* enotes_settings = NULL;
VALA_EXTERN ENotesWindow* enotes_window;
ENotesWindow* enotes_window = NULL;
VALA_EXTERN gchar* enotes_NOTES_DB;
gchar* enotes_NOTES_DB = NULL;
VALA_EXTERN gchar* enotes_NOTES_DIR;
gchar* enotes_NOTES_DIR = NULL;
static gpointer enotes_application_parent_class = NULL;

VALA_EXTERN GType enotes_key_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* enotes_key_to_key (ENotesKey self);
VALA_EXTERN gchar* enotes_key_to_string (ENotesKey self);
VALA_EXTERN GType enotes_services_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesServicesSettings, g_object_unref)
VALA_EXTERN GType enotes_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesWindow, g_object_unref)
VALA_EXTERN GType enotes_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesApplication, g_object_unref)
static void enotes_application_real_activate (GApplication* base);
VALA_EXTERN ENotesServicesSettings* enotes_services_settings_get_instance (void);
VALA_EXTERN const gchar* enotes_services_settings_get_notes_database (ENotesServicesSettings* self);
VALA_EXTERN void enotes_services_settings_set_notes_database (ENotesServicesSettings* self,
                                                  const gchar* value);
VALA_EXTERN const gchar* enotes_services_settings_get_notes_location (ENotesServicesSettings* self);
VALA_EXTERN gboolean enotes_services_settings_get_import_files (ENotesServicesSettings* self);
VALA_EXTERN void enotes_file_manager_import_files (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType enotes_notebook_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesNotebookTable, database_table_unref)
VALA_EXTERN ENotesNotebookTable* enotes_notebook_table_get_instance (void);
VALA_EXTERN GType enotes_notebook_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesNotebook, g_object_unref)
VALA_EXTERN GeeArrayList* enotes_notebook_table_get_notebooks (ENotesNotebookTable* self);
VALA_EXTERN gint64 enotes_notebook_table_new_notebook (ENotesNotebookTable* self,
                                           gint64 parent,
                                           const gchar* name,
                                           GdkRGBA* rgb,
                                           const gchar* css,
                                           const gchar* stylesheet);
VALA_EXTERN ENotesWindow* enotes_window_new (GtkApplication* app);
VALA_EXTERN ENotesWindow* enotes_window_construct (GType object_type,
                                       GtkApplication* app);
VALA_EXTERN void enotes_window_show_app (ENotesWindow* self);
VALA_EXTERN ENotesApplication* enotes_application_new (void);
VALA_EXTERN ENotesApplication* enotes_application_construct (GType object_type);
static GObject * enotes_application_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void enotes_application_finalize (GObject * obj);
static GType enotes_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
enotes_key_to_key (ENotesKey self)
{
	gchar* result;
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	switch (self) {
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_CHANGE_MODE:
#line 228 "Application.c"
		{
			gchar* _tmp0_;
#line 36 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp0_ = g_strdup (_ ("<Ctrl>M"));
#line 36 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp0_;
#line 36 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 237 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_SAVE:
#line 241 "Application.c"
		{
			gchar* _tmp1_;
#line 37 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp1_ = g_strdup (_ ("<Ctrl>S"));
#line 37 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp1_;
#line 37 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 250 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_QUIT:
#line 254 "Application.c"
		{
			gchar* _tmp2_;
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp2_ = g_strdup (_ ("<Ctrl>Q"));
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp2_;
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 263 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_NEW_PAGE:
#line 267 "Application.c"
		{
			gchar* _tmp3_;
#line 39 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp3_ = g_strdup (_ ("<Ctrl><Shift>N"));
#line 39 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp3_;
#line 39 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 276 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_FIND:
#line 280 "Application.c"
		{
			gchar* _tmp4_;
#line 40 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp4_ = g_strdup (_ ("<Ctrl>F"));
#line 40 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp4_;
#line 40 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 289 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_BOOKMARK:
#line 293 "Application.c"
		{
			gchar* _tmp5_;
#line 41 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp5_ = g_strdup (_ ("<Ctrl>K"));
#line 41 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp5_;
#line 41 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 302 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_BOLD:
#line 306 "Application.c"
		{
			gchar* _tmp6_;
#line 42 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp6_ = g_strdup (_ ("<Ctrl>B"));
#line 42 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp6_;
#line 42 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 315 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_ITALICS:
#line 319 "Application.c"
		{
			gchar* _tmp7_;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp7_ = g_strdup (_ ("<Ctrl>I"));
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp7_;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 328 "Application.c"
		}
#line 34 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		case ENOTES_KEY_STRIKE:
#line 332 "Application.c"
		{
			gchar* _tmp8_;
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp8_ = g_strdup (_ ("<Ctrl>T"));
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			result = _tmp8_;
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			return result;
#line 341 "Application.c"
		}
		default:
		{
#line 45 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			g_assert_not_reached ();
#line 347 "Application.c"
		}
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 371 "Application.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 375 "Application.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 381 "Application.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 385 "Application.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 389 "Application.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 397 "Application.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 425 "Application.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 434 "Application.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 448 "Application.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 457 "Application.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 471 "Application.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 480 "Application.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 489 "Application.c"
}

gchar*
enotes_key_to_string (ENotesKey self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp0_ = enotes_key_to_key (self);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp1_ = _tmp0_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp2_ = string_replace (_tmp1_, ">", "+");
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp3_ = _tmp2_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp4_ = string_replace (_tmp3_, "<", "");
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp5_ = _tmp4_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp7_ = _tmp6_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp9_ = _tmp8_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (_tmp7_);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (_tmp5_);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (_tmp3_);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (_tmp1_);
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	result = _tmp9_;
#line 50 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	return result;
#line 538 "Application.c"
}

static GType
enotes_key_get_type_once (void)
{
	static const GEnumValue values[] = {{ENOTES_KEY_CHANGE_MODE, "ENOTES_KEY_CHANGE_MODE", "change-mode"}, {ENOTES_KEY_SAVE, "ENOTES_KEY_SAVE", "save"}, {ENOTES_KEY_QUIT, "ENOTES_KEY_QUIT", "quit"}, {ENOTES_KEY_NEW_PAGE, "ENOTES_KEY_NEW_PAGE", "new-page"}, {ENOTES_KEY_FIND, "ENOTES_KEY_FIND", "find"}, {ENOTES_KEY_BOOKMARK, "ENOTES_KEY_BOOKMARK", "bookmark"}, {ENOTES_KEY_BOLD, "ENOTES_KEY_BOLD", "bold"}, {ENOTES_KEY_ITALICS, "ENOTES_KEY_ITALICS", "italics"}, {ENOTES_KEY_STRIKE, "ENOTES_KEY_STRIKE", "strike"}, {0, NULL, NULL}};
	GType enotes_key_type_id;
	enotes_key_type_id = g_enum_register_static ("ENotesKey", values);
	return enotes_key_type_id;
}

GType
enotes_key_get_type (void)
{
	static volatile gsize enotes_key_type_id__once = 0;
	if (g_once_init_enter (&enotes_key_type_id__once)) {
		GType enotes_key_type_id;
		enotes_key_type_id = enotes_key_get_type_once ();
		g_once_init_leave (&enotes_key_type_id__once, enotes_key_type_id);
	}
	return enotes_key_type_id__once;
}

static void
enotes_application_real_activate (GApplication* base)
{
	ENotesApplication * self;
	ENotesWindow* _tmp34_;
#line 87 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	self = (ENotesApplication*) base;
#line 88 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	if (!self->running) {
#line 571 "Application.c"
		ENotesServicesSettings* _tmp0_;
		ENotesServicesSettings* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		ENotesServicesSettings* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		ENotesServicesSettings* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		ENotesServicesSettings* _tmp19_;
		gboolean _tmp20_;
		gboolean _tmp21_;
		ENotesWindow* _tmp32_;
		ENotesWindow* _tmp33_;
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp0_ = enotes_services_settings_get_instance ();
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_g_object_unref0 (enotes_settings);
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		enotes_settings = _tmp0_;
#line 91 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp1_ = enotes_settings;
#line 91 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp2_ = enotes_services_settings_get_notes_database (_tmp1_);
#line 91 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp3_ = _tmp2_;
#line 91 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		if (g_strcmp0 (_tmp3_, "") == 0) {
#line 603 "Application.c"
			gchar* notes_dir = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			ENotesServicesSettings* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 92 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp4_ = g_get_home_dir ();
#line 92 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp5_ = g_strconcat (_tmp4_, "/.local/share/notes-up/", NULL);
#line 92 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			notes_dir = _tmp5_;
#line 93 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp6_ = notes_dir;
#line 93 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			g_mkdir_with_parents (_tmp6_, 0766);
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp7_ = enotes_settings;
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp8_ = notes_dir;
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp9_ = g_strconcat (_tmp8_, "NotesUp.db", NULL);
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp10_ = _tmp9_;
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			enotes_services_settings_set_notes_database (_tmp7_, _tmp10_);
#line 94 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_g_free0 (_tmp10_);
#line 91 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_g_free0 (notes_dir);
#line 636 "Application.c"
		}
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp11_ = enotes_settings;
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp12_ = enotes_services_settings_get_notes_location (_tmp11_);
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp13_ = _tmp12_;
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_g_free0 (enotes_NOTES_DIR);
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		enotes_NOTES_DIR = _tmp14_;
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp15_ = enotes_settings;
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp16_ = enotes_services_settings_get_notes_database (_tmp15_);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp17_ = _tmp16_;
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_g_free0 (enotes_NOTES_DB);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		enotes_NOTES_DB = _tmp18_;
#line 100 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp19_ = enotes_settings;
#line 100 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp20_ = enotes_services_settings_get_import_files (_tmp19_);
#line 100 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp21_ = _tmp20_;
#line 100 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		if (_tmp21_) {
#line 670 "Application.c"
			ENotesNotebookTable* _tmp22_;
			ENotesNotebookTable* _tmp23_;
			GeeArrayList* _tmp24_;
			GeeArrayList* _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
			gboolean _tmp28_;
#line 101 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			enotes_file_manager_import_files ();
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp22_ = enotes_notebook_table_get_instance ();
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp23_ = _tmp22_;
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp24_ = enotes_notebook_table_get_notebooks (_tmp23_);
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp25_ = _tmp24_;
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp27_ = _tmp26_;
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_tmp28_ = _tmp27_ == 0;
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_g_object_unref0 (_tmp25_);
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			_database_table_unref0 (_tmp23_);
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
			if (_tmp28_) {
#line 700 "Application.c"
				ENotesNotebookTable* _tmp29_;
				ENotesNotebookTable* _tmp30_;
				GdkRGBA _tmp31_ = {0};
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_tmp29_ = enotes_notebook_table_get_instance ();
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_tmp30_ = _tmp29_;
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_tmp31_.red = 0.7;
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_tmp31_.green = (gdouble) 0;
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_tmp31_.blue = (gdouble) 0;
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				enotes_notebook_table_new_notebook (_tmp30_, (gint64) 0, _ ("New Notebook"), &_tmp31_, "", "");
#line 104 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
				_database_table_unref0 (_tmp30_);
#line 718 "Application.c"
			}
		}
#line 108 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp32_ = enotes_window_new ((GtkApplication*) self);
#line 108 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		g_object_ref_sink (_tmp32_);
#line 108 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_g_object_unref0 (enotes_window);
#line 108 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		enotes_window = _tmp32_;
#line 109 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		_tmp33_ = enotes_window;
#line 109 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp33_);
#line 111 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
		self->running = TRUE;
#line 735 "Application.c"
	}
#line 114 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp34_ = enotes_window;
#line 114 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	enotes_window_show_app (_tmp34_);
#line 741 "Application.c"
}

ENotesApplication*
enotes_application_construct (GType object_type)
{
	ENotesApplication * self = NULL;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	self = (ENotesApplication*) granite_application_construct (object_type);
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	return self;
#line 752 "Application.c"
}

ENotesApplication*
enotes_application_new (void)
{
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	return enotes_application_construct (ENOTES_TYPE_APPLICATION);
#line 760 "Application.c"
}

static GObject *
enotes_application_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ENotesApplication * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar* _tmp12_;
#line 68 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	parent_class = G_OBJECT_CLASS (enotes_application_parent_class);
#line 68 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 68 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ENOTES_TYPE_APPLICATION, ENotesApplication);
#line 69 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	g_application_set_application_id ((GApplication*) self, "com.github.philip-scott.notes-up");
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp0_ = g_strdup (ENOTES_APPLICATION_PROGRAM_NAME);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->program_name);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->program_name = _tmp0_;
#line 71 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp1_ = g_strdup ("2015-2017");
#line 71 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->app_years);
#line 71 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->app_years = _tmp1_;
#line 72 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp2_ = g_strdup (TERMINAL_NAME);
#line 72 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->exec_name);
#line 72 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->exec_name = _tmp2_;
#line 73 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp3_ = g_strdup ("com.github.philip-scott.notes-up");
#line 73 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->app_launcher);
#line 73 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->app_launcher = _tmp3_;
#line 75 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp4_ = g_strdup (CONSTANTS_VERSION);
#line 75 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->build_version);
#line 75 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->build_version = _tmp4_;
#line 76 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp5_ = g_strdup ("com.github.philip-scott.notes-up");
#line 76 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->app_icon);
#line 76 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->app_icon = _tmp5_;
#line 77 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp6_ = g_strdup ("https://github.com/Philip-Scott/Notes-up/");
#line 77 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->main_url);
#line 77 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->main_url = _tmp6_;
#line 78 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp7_ = g_strdup ("https://github.com/Philip-Scott/Notes-up/issues");
#line 78 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->bug_url);
#line 78 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->bug_url = _tmp7_;
#line 79 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp8_ = g_strdup ("https://github.com/Philip-Scott/Notes-up/");
#line 79 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->help_url);
#line 79 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->help_url = _tmp8_;
#line 80 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp9_ = g_strdup ("https://github.com/Philip-Scott/Notes-up/tree/master/po");
#line 80 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->translate_url);
#line 80 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->translate_url = _tmp9_;
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp10_ = g_strdup ("Felipe Escoto <felescoto95@hotmail.com>");
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp11_ = g_new0 (gchar*, 2 + 1);
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp11_[0] = _tmp10_;
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp11_[1] = NULL;
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->about_authors = (_vala_array_free (((GraniteApplication*) self)->about_authors, ((GraniteApplication*) self)->about_authors_length1, (GDestroyNotify) g_free), NULL);
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->about_authors = _tmp11_;
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->about_authors_length1 = 2;
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_tmp12_ = g_strdup (_ ("translator-credits"));
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	_g_free0 (((GraniteApplication*) self)->about_translators);
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->about_translators = _tmp12_;
#line 84 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GraniteApplication*) self)->about_license_type = GTK_LICENSE_GPL_3_0;
#line 68 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	return obj;
#line 876 "Application.c"
}

static void
enotes_application_class_init (ENotesApplicationClass * klass,
                               gpointer klass_data)
{
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	enotes_application_parent_class = g_type_class_peek_parent (klass);
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) enotes_application_real_activate;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = enotes_application_constructor;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = enotes_application_finalize;
#line 891 "Application.c"
}

static void
enotes_application_instance_init (ENotesApplication * self,
                                  gpointer klass)
{
#line 66 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	self->running = FALSE;
#line 900 "Application.c"
}

static void
enotes_application_finalize (GObject * obj)
{
	ENotesApplication * self;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ENOTES_TYPE_APPLICATION, ENotesApplication);
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Application.vala"
	G_OBJECT_CLASS (enotes_application_parent_class)->finalize (obj);
#line 911 "Application.c"
}

static GType
enotes_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ENotesApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) enotes_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ENotesApplication), 0, (GInstanceInitFunc) enotes_application_instance_init, NULL };
	GType enotes_application_type_id;
	enotes_application_type_id = g_type_register_static (GRANITE_TYPE_APPLICATION, "ENotesApplication", &g_define_type_info, 0);
	return enotes_application_type_id;
}

GType
enotes_application_get_type (void)
{
	static volatile gsize enotes_application_type_id__once = 0;
	if (g_once_init_enter (&enotes_application_type_id__once)) {
		GType enotes_application_type_id;
		enotes_application_type_id = enotes_application_get_type_once ();
		g_once_init_leave (&enotes_application_type_id__once, enotes_application_type_id);
	}
	return enotes_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

