/* Viewer.c generated by valac 0.56.14, the Vala compiler
 * generated from Viewer.vala, do not modify */

/*
* Copyright (c) 2011-2016 Felipe Escoto (https://github.com/Philip-Scott/Notes-up)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
* Authored by: Felipe Escoto <felescoto95@hotmail.com>
*/

#include <webkit2/webkit2.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include <mkdio.h>

#define ENOTES_STYLES_ELEMENTARY_css "\n" \
"html,\n" \
"body {\n" \
"    margin: 1em;\n" \
"\n" \
"    background-color: #fff;\n" \
"\n" \
"    font-size: 16px;\n" \
"    font-family: \"Open Sans\", \"Droid Sans\", Helvetica, sans-serif;" \
"\n" \
"    font-weight: 400;\n" \
"    color: #333;\n" \
"}\n" \
"\n" \
"body * {\n" \
"    max-width: 800px;\n" \
"    margin-left: auto;\n" \
"    margin-right: auto;\n" \
"}\n" \
"\n" \
"/**************\n" \
"* Text Styles *\n" \
"**************/\n" \
"\n" \
"a{\n" \
"    color: #08c;\n" \
"    text-decoration: none;\n" \
"}\n" \
"\n" \
"a:focus{\n" \
"    outline: none;\n" \
"    text-decoration: underline;\n" \
"}\n" \
"\n" \
"h1,\n" \
"h2,\n" \
"h3,\n" \
"h4,\n" \
"h5,\n" \
"h6{\n" \
"    margin: 1.5em 0 0.25em;\n" \
"    padding: 0;\n" \
"    text-align: left;\n" \
"}\n" \
"\n" \
"h4,\n" \
"h5,\n" \
"h6{\n" \
"    margin-top: 2em;\n" \
"    margin-bottom: 0;\n" \
"}\n" \
"\n" \
"h1{\n" \
"    margin-top: 0;\n" \
"\n" \
"    font-family: \"Raleway\", \"Open Sans\", \"Droid Sans\", Helvetica" \
", sans-serif;\n" \
"    font-size: 3rem;\n" \
"    font-weight: 200;\n" \
"    text-align: center;\n" \
"}\n" \
"\n" \
"h1 + h1 {\n" \
"    color: #666;\n" \
"    margin: 0em 0 0em;\n" \
"    font-size: 2.5rem;\n" \
"}\n" \
"\n" \
"h2 {\n" \
"    font-size: 2rem;\n" \
"    font-weight: 600;\n" \
"}\n" \
"\n" \
"h2 + h2 {\n" \
"    font-size: 1.50rem;\n" \
"    margin: 0em 0 0.25em;\n" \
"}\n" \
"\n" \
"h3{\n" \
"    font-size: 1.5rem;\n" \
"    font-weight: 600;\n" \
"\n" \
"    opacity: 0.8;\n" \
"}\n" \
"\n" \
"h4{\n" \
"    font-size: 1.125rem;\n" \
"    font-weight: 300;\n" \
"}\n" \
"\n" \
"h5{\n" \
"    font-size: 1rem;\n" \
"    font-weight: 600;\n" \
"}\n" \
"\n" \
"p {\n" \
"    text-align: left;\n" \
"}\n" \
"\n" \
"/*******\n" \
"* Code *\n" \
"*******/\n" \
"\n" \
"code{\n" \
"    display: inline-block;\n" \
"    padding: 0 0.25em;\n" \
"\n" \
"    background-color: #f3f3f3;\n" \
"\n" \
"    border: 1px solid #ddd;\n" \
"    border-radius: 3px;\n" \
"\n" \
"    font-family: \"Droid Sans Mono\",\"DejaVu Mono\",mono;\n" \
"    font-weight: normal;\n" \
"    color: #403a36;\n" \
"}\n" \
"\n" \
"pre code{\n" \
"    display: block;\n" \
"    margin: 1em auto;\n" \
"    overflow-x: scroll;\n" \
"}\n" \
"\n" \
"/***********\n" \
"* Keyboard *\n" \
"***********/\n" \
"\n" \
"kbd{\n" \
"    padding: 2px 4px;\n" \
"    margin: 3px;\n" \
"\n" \
"    background-color: #eee;\n" \
"    background-image: linear-gradient(to bottom, #eee, #fff);\n" \
"\n" \
"    border: 1px solid #a5a5a5;\n" \
"    border-radius: 3px;\n" \
"\n" \
"    box-shadow: inset 0 1px 0 0 #fff,\n" \
"        inset 0 -2px 0px 0 #d9d9d9,\n" \
"        0 1px 2px 0 rgba(0,0,0,0.1);\n" \
"\n" \
"    font-family: inherit;\n" \
"    font-size: inherit;\n" \
"    font-weight: 500;\n" \
"    color: #4d4d4d;\n" \
"}\n" \
"\n" \
"/*********\n" \
"* Images *\n" \
"*********/\n" \
"\n" \
"img{\n" \
"    display: block;\n" \
"    margin: 1em auto;\n" \
"    max-width: 100%;\n" \
"}\n" \
"\n" \
"/******************\n" \
"* Horizontal Rule *\n" \
"******************/\n" \
"\n" \
"hr{\n" \
"    margin: 2em;\n" \
"    height: 1px;\n" \
"\n" \
"    background-image: -webkit-linear-gradient(left, rgba(0,0,0,0), rgb" \
"a(0,0,0,0.5), rgba(0,0,0,0));\n" \
"\n" \
"    border: 0;\n" \
"}\n" \
"\n" \
"\n" \
"/********\n" \
"* Table *\n" \
"********/\n" \
"\n" \
"table {\n" \
"    border-collapse: collapse;\n" \
"}\n" \
"\n" \
"th, td {\n" \
"    padding: 8px;\n" \
"}\n" \
"\n" \
"tr:nth-child(even){background-color: #fafafa}\n" \
"\n" \
"\n" \
"blockquote {\n" \
"    border-left: 4px solid #dddddd;\n" \
"    padding: 0 15px;\n" \
"    color: #777777;\n" \
"}\n" \
"\n" \
"blockquote > :first-child {\n" \
"    margin-top: 0;\n" \
"}\n" \
"\n" \
"blockquote > :last-child {\n" \
"    margin-bottom: 0;\n" \
"}\n"
#define ENOTES_STYLES_MODEST_css "\n" \
"pre,\n" \
"code {\n" \
"  font-family: Menlo, Monaco, \"Courier New\", monospace;\n" \
"}\n" \
"\n" \
"pre {\n" \
"  padding: .5rem;\n" \
"  line-height: 1.25;\n" \
"  overflow-x: scroll;\n" \
"}\n" \
"\n" \
"a,\n" \
"a:visited {\n" \
"  color: #3498db;\n" \
"}\n" \
"\n" \
"a:hover,\n" \
"a:focus,\n" \
"a:active {\n" \
"  color: #2980b9;\n" \
"}\n" \
"\n" \
".modest-no-decoration {\n" \
"  text-decoration: none;\n" \
"}\n" \
"\n" \
"html {\n" \
"  font-size: 12px;\n" \
"}\n" \
"\n" \
"body {\n" \
"  line-height: 1.85;\n" \
"}\n" \
"\n" \
"p,\n" \
".modest-p {\n" \
"  font-size: 1rem;\n" \
"  margin-bottom: 1.3rem;\n" \
"}\n" \
"\n" \
"h1,\n" \
".modest-h1,\n" \
"h2,\n" \
".modest-h2,\n" \
"h3,\n" \
".modest-h3,\n" \
"h4,\n" \
".modest-h4 {\n" \
"  margin: 1.414rem 0 .5rem;\n" \
"  font-weight: inherit;\n" \
"  line-height: 1.42;\n" \
"}\n" \
"\n" \
"h1,\n" \
".modest-h1 {\n" \
"  margin-top: 0;\n" \
"  font-size: 3rem;\n" \
"}\n" \
"\n" \
"h2,\n" \
".modest-h2 {\n" \
"  font-size: 1.4rem;\n" \
"}\n" \
"\n" \
"h3,\n" \
".modest-h3 {\n" \
"  font-size: 1.6rem;\n" \
"}\n" \
"\n" \
"h4,\n" \
".modest-h4 {\n" \
"  font-size: 1.4rem;\n" \
"}\n" \
"\n" \
"h5,\n" \
".modest-h5 {\n" \
"  font-size: 1.121rem;\n" \
"}\n" \
"\n" \
"h6,\n" \
".modest-h6 {\n" \
"  font-size: .88rem;\n" \
"}\n" \
"\n" \
"small,\n" \
".modest-small {\n" \
"  font-size: .707em;\n" \
"}\n" \
"\n" \
"/* https://github.com/mrmrs/fluidity */\n" \
"\n" \
"img,\n" \
"canvas,\n" \
"iframe,\n" \
"video,\n" \
"svg,\n" \
"select,\n" \
"textarea {\n" \
"  max-width: 100%;\n" \
"}\n" \
"\n" \
"@import url(http://fonts.googleapis.com/css?family=Arimo:700,700italic" \
");\n" \
"\n" \
"html {\n" \
"  font-size: 18px;\n" \
"  max-width: 100%;\n" \
"}\n" \
"\n" \
"body {\n" \
"  color: #222;\n" \
"  font-family: 'Open Sans', sans-serif;\n" \
"  font-weight: 300;\n" \
"  margin: 0 auto;\n" \
"  max-width: 48rem;\n" \
"  line-height: 1.45;\n" \
"  padding: .25rem;\n" \
"}\n" \
"\n" \
"h1,\n" \
"h2,\n" \
"h3,\n" \
"h4,\n" \
"h5,\n" \
"h6 {\n" \
"  font-family: Arimo, Helvetica, sans-serif;\n" \
"}\n" \
"\n" \
"h1 {\n" \
"  border-bottom: 2px solid #fafafa;\n" \
"  margin-bottom: 1.15rem;\n" \
"  padding-bottom: .5rem;\n" \
"  text-align: center;\n" \
"}\n" \
"\n" \
"blockquote {\n" \
"  border-left: 8px solid #fafafa;\n" \
"  padding: 1rem;\n" \
"}\n" \
"\n" \
"pre,\n" \
"code {\n" \
"  background-color: #fafafa;\n" \
"} "
#define ENOTES_STYLES_AIR_css "\n" \
"html {\n" \
"  font-size: 16px;\n" \
"}\n" \
"\n" \
"body {\n" \
"  line-height: 1.85;\n" \
"}\n" \
"\n" \
"p,\n" \
".air-p {\n" \
"  font-size: 1rem;\n" \
"  margin-bottom: 1.3rem;\n" \
"}\n" \
"\n" \
"h1,\n" \
".air-h1,\n" \
"h2,\n" \
".air-h2,\n" \
"h3,\n" \
".air-h3,\n" \
"h4,\n" \
".air-h4 {\n" \
"  margin: 1.214rem 0 .5rem;\n" \
"  font-weight: inherit;\n" \
"  line-height: 1.42;\n" \
"}\n" \
"\n" \
"h1,\n" \
".air-h1 {\n" \
"  margin-top: 0;\n" \
"  font-size: 3rem;\n" \
"}\n" \
"\n" \
"h2,\n" \
".air-h2 {\n" \
"  font-size: 2rem;\n" \
"}\n" \
"\n" \
"h3,\n" \
".air-h3 {\n" \
"  font-size: 1.5rem;\n" \
"}\n" \
"\n" \
"h4,\n" \
".air-h4 {\n" \
"  font-size: 1.214rem;\n" \
"}\n" \
"\n" \
"h5,\n" \
".air-h5 {\n" \
"  font-size: 1.121rem;\n" \
"}\n" \
"\n" \
"h6,\n" \
".air-h6 {\n" \
"  font-size: .88rem;\n" \
"}\n" \
"\n" \
"small,\n" \
".air-small {\n" \
"  font-size: .707em;\n" \
"}\n" \
"\n" \
"/* https://github.com/mrmrs/fluidity */\n" \
"\n" \
"img,\n" \
"canvas,\n" \
"iframe,\n" \
"video,\n" \
"svg,\n" \
"select,\n" \
"textarea {\n" \
"  display: block;\n" \
"  max-width: 40%;\n" \
"}\n" \
"\n" \
"body {\n" \
"  color: #222;\n" \
"  font-family: 'Open Sans', Helvetica, sans-serif;\n" \
"  font-weight: 300;\n" \
"  margin-left: auto;\n" \
"  margin-right: auto;\n" \
"  max-width: 48rem;\n" \
"  text-align: center;\n" \
"}\n" \
"\n" \
"img {\n" \
"  border-radius: 10%;\n" \
"  height: auto;\n" \
"  margin: 0 auto;\n" \
"}\n" \
"\n" \
"a,\n" \
"a:visited {\n" \
"  color: #3498db;\n" \
"}\n" \
"\n" \
"a:hover,\n" \
"a:focus,\n" \
"a:active {\n" \
"  color: #2980b9;\n" \
"}\n" \
"\n" \
"pre {\n" \
"  background-color: #fafafa;\n" \
"  padding: 1rem;\n" \
"  text-align: left;\n" \
"}\n" \
"\n" \
"blockquote {\n" \
"  margin: 0;\n" \
"  border-left: 5px solid #7a7a7a;\n" \
"  font-style: italic;\n" \
"  padding: 1em;\n" \
"  text-align: left;\n" \
"}\n" \
"\n" \
"ul,\n" \
"ol,\n" \
"li {\n" \
"  text-align: left;\n" \
"}\n" \
"\n" \
"p {\n" \
"  color: #444;\n" \
"}"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define ENOTES_TYPE_VIEWER (enotes_viewer_get_type ())
#define ENOTES_VIEWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_VIEWER, ENotesViewer))
#define ENOTES_VIEWER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_VIEWER, ENotesViewerClass))
#define ENOTES_IS_VIEWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_VIEWER))
#define ENOTES_IS_VIEWER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_VIEWER))
#define ENOTES_VIEWER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_VIEWER, ENotesViewerClass))

typedef struct _ENotesViewer ENotesViewer;
typedef struct _ENotesViewerClass ENotesViewerClass;
typedef struct _ENotesViewerPrivate ENotesViewerPrivate;

#define ENOTES_TYPE_PAGE (enotes_page_get_type ())
#define ENOTES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_PAGE, ENotesPage))
#define ENOTES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_PAGE, ENotesPageClass))
#define ENOTES_IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_PAGE))
#define ENOTES_IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_PAGE))
#define ENOTES_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_PAGE, ENotesPageClass))

typedef struct _ENotesPage ENotesPage;
typedef struct _ENotesPageClass ENotesPageClass;
enum  {
	ENOTES_VIEWER_0_PROPERTY,
	ENOTES_VIEWER_NUM_PROPERTIES
};
static GParamSpec* enotes_viewer_properties[ENOTES_VIEWER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ENotesPagePrivate ENotesPagePrivate;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define ENOTES_TYPE_NOTEBOOK_TABLE (enotes_notebook_table_get_type ())
#define ENOTES_NOTEBOOK_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTable))
#define ENOTES_NOTEBOOK_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTableClass))
#define ENOTES_IS_NOTEBOOK_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_NOTEBOOK_TABLE))
#define ENOTES_IS_NOTEBOOK_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_NOTEBOOK_TABLE))
#define ENOTES_NOTEBOOK_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_NOTEBOOK_TABLE, ENotesNotebookTableClass))

typedef struct _ENotesNotebookTable ENotesNotebookTable;
typedef struct _ENotesNotebookTableClass ENotesNotebookTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define ENOTES_SERVICES_TYPE_SETTINGS (enotes_services_settings_get_type ())
#define ENOTES_SERVICES_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettings))
#define ENOTES_SERVICES_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettingsClass))
#define ENOTES_SERVICES_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_SERVICES_TYPE_SETTINGS))
#define ENOTES_SERVICES_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_SERVICES_TYPE_SETTINGS))
#define ENOTES_SERVICES_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_SERVICES_TYPE_SETTINGS, ENotesServicesSettingsClass))

typedef struct _ENotesServicesSettings ENotesServicesSettings;
typedef struct _ENotesServicesSettingsClass ENotesServicesSettingsClass;
typedef enum  {
	ENOTES_MODE_VIEW = 0,
	ENOTES_MODE_EDIT = 1
} ENotesMode;

#define ENOTES_TYPE_MODE (enotes_mode_get_type ())

#define ENOTES_TYPE_PAGE_TABLE (enotes_page_table_get_type ())
#define ENOTES_PAGE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_PAGE_TABLE, ENotesPageTable))
#define ENOTES_PAGE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_PAGE_TABLE, ENotesPageTableClass))
#define ENOTES_IS_PAGE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_PAGE_TABLE))
#define ENOTES_IS_PAGE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_PAGE_TABLE))
#define ENOTES_PAGE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_PAGE_TABLE, ENotesPageTableClass))

typedef struct _ENotesPageTable ENotesPageTable;
typedef struct _ENotesPageTableClass ENotesPageTableClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _mkd_cleanup0(var) ((var == NULL) ? NULL : (var = (mkd_cleanup (var), NULL)))

#define ENOTES_TYPE_PLUGIN_MANAGER (enotes_plugin_manager_get_type ())
#define ENOTES_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_PLUGIN_MANAGER, ENotesPluginManager))
#define ENOTES_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_PLUGIN_MANAGER, ENotesPluginManagerClass))
#define ENOTES_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_PLUGIN_MANAGER))
#define ENOTES_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_PLUGIN_MANAGER))
#define ENOTES_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_PLUGIN_MANAGER, ENotesPluginManagerClass))

typedef struct _ENotesPluginManager ENotesPluginManager;
typedef struct _ENotesPluginManagerClass ENotesPluginManagerClass;

#define ENOTES_TYPE_PLUGIN (enotes_plugin_get_type ())
#define ENOTES_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ENOTES_TYPE_PLUGIN, ENotesPlugin))
#define ENOTES_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ENOTES_TYPE_PLUGIN, ENotesPluginClass))
#define ENOTES_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ENOTES_TYPE_PLUGIN))
#define ENOTES_IS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ENOTES_TYPE_PLUGIN))
#define ENOTES_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ENOTES_TYPE_PLUGIN, ENotesPluginClass))

typedef struct _ENotesPlugin ENotesPlugin;
typedef struct _ENotesPluginClass ENotesPluginClass;

struct _ENotesViewer {
	WebKitWebView parent_instance;
	ENotesViewerPrivate * priv;
	gchar* CSS;
};

struct _ENotesViewerClass {
	WebKitWebViewClass parent_class;
};

struct _ENotesViewerPrivate {
	ENotesPage* previous_page;
};

struct _ENotesPage {
	GObject parent_instance;
	ENotesPagePrivate * priv;
	gint64 id;
	gint64 notebook_id;
	gchar* name;
	gchar* data;
	gchar* subtitle;
	gchar* html_cache;
	gint64 creation_date;
	gint64 modification_date;
	gboolean new_page;
	gchar* full_path;
};

struct _ENotesPageClass {
	GObjectClass parent_class;
};

static gint ENotesViewer_private_offset;
static gpointer enotes_viewer_parent_class = NULL;
VALA_EXTERN gchar** enotes_viewer_STYLES;
VALA_EXTERN gint enotes_viewer_STYLES_length1;
gchar** enotes_viewer_STYLES = NULL;
gint enotes_viewer_STYLES_length1 = 0;
static ENotesViewer* enotes_viewer_instance;
static ENotesViewer* enotes_viewer_instance = NULL;
VALA_EXTERN ENotesServicesSettings* enotes_settings;

VALA_EXTERN GType enotes_viewer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesViewer, g_object_unref)
VALA_EXTERN GType enotes_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesPage, g_object_unref)
VALA_EXTERN ENotesViewer* enotes_viewer_get_instance (void);
static ENotesViewer* enotes_viewer_new (void);
static ENotesViewer* enotes_viewer_construct (GType object_type);
static void enotes_viewer_connect_signals (ENotesViewer* self);
VALA_EXTERN void enotes_viewer_load_css (ENotesViewer* self,
                             ENotesPage* page,
                             gboolean overrride);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType enotes_notebook_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesNotebookTable, database_table_unref)
VALA_EXTERN ENotesNotebookTable* enotes_notebook_table_get_instance (void);
VALA_EXTERN gchar* enotes_notebook_table_get_stylesheet_from_page (ENotesNotebookTable* self,
                                                       gint64 page_id);
static void enotes_viewer_set_styleshet (ENotesViewer* self,
                                  const gchar* stylesheet,
                                  gboolean trying_global);
VALA_EXTERN GType enotes_services_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesServicesSettings, g_object_unref)
VALA_EXTERN const gchar* enotes_services_settings_get_stylesheet (ENotesServicesSettings* self);
VALA_EXTERN const gchar* enotes_services_settings_get_render_stylesheet (ENotesServicesSettings* self);
VALA_EXTERN gchar* enotes_notebook_table_get_css_from_page (ENotesNotebookTable* self,
                                                gint64 page_id);
VALA_EXTERN void enotes_viewer_reload (ENotesViewer* self);
VALA_EXTERN void enotes_viewer_load_page (ENotesViewer* self,
                              ENotesPage* page,
                              gboolean force_load);
VALA_EXTERN GType enotes_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ENotesMode* enotes_view_edit_stack_get_current_mode (void);
static gboolean _enotes_mode_equal (const ENotesMode * s1,
                             const ENotesMode * s2);
static gchar** enotes_viewer_process_frontmatter (ENotesViewer* self,
                                           const gchar* raw_mk,
                                           gchar** processed_mk,
                                           gint* result_length1);
static gchar* enotes_viewer_process (ENotesViewer* self,
                              const gchar* raw_mk);
VALA_EXTERN GType enotes_page_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesPageTable, database_table_unref)
VALA_EXTERN ENotesPageTable* enotes_page_table_get_instance (void);
VALA_EXTERN void enotes_page_table_save_cache (ENotesPageTable* self,
                                   ENotesPage* page);
static GtkWidget* __lambda21_ (ENotesViewer* self,
                        WebKitNavigationAction* navigation_action);
static void enotes_viewer_launch_browser (ENotesViewer* self,
                                   const gchar* url);
static GtkWidget* ___lambda21__webkit_web_view_create (WebKitWebView* _sender,
                                                WebKitNavigationAction* navigation_action,
                                                gpointer self);
static gboolean __lambda22_ (ENotesViewer* self,
                      WebKitPolicyDecision* decision,
                      WebKitPolicyDecisionType type);
static gboolean ___lambda22__webkit_web_view_decide_policy (WebKitWebView* _sender,
                                                     WebKitPolicyDecision* decision,
                                                     WebKitPolicyDecisionType type,
                                                     gpointer self);
static void __lambda23_ (ENotesViewer* self,
                  WebKitLoadEvent event);
static void ___lambda23__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                WebKitLoadEvent load_event,
                                                gpointer self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gchar* enotes_viewer_process_plugins (ENotesViewer* self,
                                      const gchar* raw_mk);
VALA_EXTERN GType enotes_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesPluginManager, g_object_unref)
VALA_EXTERN ENotesPluginManager* enotes_plugin_manager_get_instance (void);
VALA_EXTERN GType enotes_plugin_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ENotesPlugin, g_object_unref)
VALA_EXTERN ENotesPlugin** enotes_plugin_manager_get_plugs (ENotesPluginManager* self,
                                                gint* result_length1);
VALA_EXTERN gboolean enotes_plugin_has_match (ENotesPlugin* self,
                                  const gchar* text);
VALA_EXTERN gchar* enotes_plugin_convert (ENotesPlugin* self,
                              const gchar* line);
static void enotes_viewer_finalize (GObject * obj);
static GType enotes_viewer_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
enotes_viewer_get_instance_private (ENotesViewer* self)
{
	return G_STRUCT_MEMBER_P (self, ENotesViewer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return self ? g_object_ref (self) : NULL;
#line 312 "Viewer.c"
}

ENotesViewer*
enotes_viewer_get_instance (void)
{
	ENotesViewer* _tmp0_;
	ENotesViewer* _tmp2_;
	ENotesViewer* _tmp3_;
	ENotesViewer* result;
#line 31 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = enotes_viewer_instance;
#line 31 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp0_ == NULL) {
#line 326 "Viewer.c"
		ENotesViewer* _tmp1_;
#line 32 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = enotes_viewer_new ();
#line 32 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		g_object_ref_sink (_tmp1_);
#line 32 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_object_unref0 (enotes_viewer_instance);
#line 32 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		enotes_viewer_instance = _tmp1_;
#line 336 "Viewer.c"
	}
#line 35 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = enotes_viewer_instance;
#line 35 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 35 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = _tmp3_;
#line 35 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 346 "Viewer.c"
}

static ENotesViewer*
enotes_viewer_construct (GType object_type)
{
	ENotesViewer * self = NULL;
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	self = (ENotesViewer*) g_object_new (object_type, NULL);
#line 39 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	enotes_viewer_connect_signals (self);
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return self;
#line 359 "Viewer.c"
}

static ENotesViewer*
enotes_viewer_new (void)
{
#line 38 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return enotes_viewer_construct (ENOTES_TYPE_VIEWER);
#line 367 "Viewer.c"
}

void
enotes_viewer_load_css (ENotesViewer* self,
                        ENotesPage* page,
                        gboolean overrride)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 42 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (overrride) {
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = TRUE;
#line 383 "Viewer.c"
	} else {
		ENotesPage* _tmp2_;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp2_ = self->priv->previous_page;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = _tmp2_ == NULL;
#line 390 "Viewer.c"
	}
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp1_) {
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp0_ = TRUE;
#line 396 "Viewer.c"
	} else {
		ENotesPage* _tmp3_;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp3_ = self->priv->previous_page;
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp0_ = _tmp3_->id != page->id;
#line 403 "Viewer.c"
	}
#line 43 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp0_) {
#line 407 "Viewer.c"
		ENotesPage* _tmp5_;
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (page != NULL) {
#line 411 "Viewer.c"
			ENotesPage* _tmp4_;
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp4_ = _g_object_ref0 (page);
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_object_unref0 (self->priv->previous_page);
#line 44 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			self->priv->previous_page = _tmp4_;
#line 419 "Viewer.c"
		}
#line 47 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp5_ = self->priv->previous_page;
#line 47 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (_tmp5_ != NULL) {
#line 425 "Viewer.c"
			gchar* stylesheet = NULL;
			ENotesNotebookTable* _tmp6_;
			ENotesNotebookTable* _tmp7_;
			ENotesPage* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp6_ = enotes_notebook_table_get_instance ();
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp7_ = _tmp6_;
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp8_ = self->priv->previous_page;
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp9_ = enotes_notebook_table_get_stylesheet_from_page (_tmp7_, _tmp8_->id);
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp10_ = _tmp9_;
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_database_table_unref0 (_tmp7_);
#line 48 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			stylesheet = _tmp10_;
#line 49 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp11_ = stylesheet;
#line 49 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			enotes_viewer_set_styleshet (self, _tmp11_, FALSE);
#line 47 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (stylesheet);
#line 453 "Viewer.c"
		}
	}
}

static void
enotes_viewer_set_styleshet (ENotesViewer* self,
                             const gchar* stylesheet,
                             gboolean trying_global)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	static GQuark _tmp1_label0 = 0;
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	static GQuark _tmp1_label1 = 0;
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	static GQuark _tmp1_label2 = 0;
#line 54 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 54 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (stylesheet != NULL);
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = stylesheet;
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("elementary")))) {
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		switch (0) {
#line 483 "Viewer.c"
			default:
			{
				gchar* _tmp3_;
#line 56 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp3_ = g_strdup (ENOTES_STYLES_ELEMENTARY_css);
#line 56 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_free0 (self->CSS);
#line 56 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				self->CSS = _tmp3_;
#line 56 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 495 "Viewer.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Modest")))) {
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		switch (0) {
#line 501 "Viewer.c"
			default:
			{
				gchar* _tmp4_;
#line 57 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp4_ = g_strdup (ENOTES_STYLES_MODEST_css);
#line 57 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_free0 (self->CSS);
#line 57 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				self->CSS = _tmp4_;
#line 57 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 513 "Viewer.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Air")))) {
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		switch (0) {
#line 519 "Viewer.c"
			default:
			{
				gchar* _tmp5_;
#line 58 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp5_ = g_strdup (ENOTES_STYLES_AIR_css);
#line 58 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_free0 (self->CSS);
#line 58 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				self->CSS = _tmp5_;
#line 58 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 531 "Viewer.c"
			}
		}
	} else {
#line 55 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		switch (0) {
#line 537 "Viewer.c"
			default:
			{
#line 60 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				if (trying_global == FALSE) {
#line 542 "Viewer.c"
					ENotesServicesSettings* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp6_ = enotes_settings;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp7_ = enotes_services_settings_get_stylesheet (_tmp6_);
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp8_ = _tmp7_;
#line 61 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					enotes_viewer_set_styleshet (self, _tmp8_, TRUE);
#line 554 "Viewer.c"
				} else {
					gchar* _tmp9_;
#line 63 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp9_ = g_strdup (ENOTES_STYLES_ELEMENTARY_css);
#line 63 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_g_free0 (self->CSS);
#line 63 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					self->CSS = _tmp9_;
#line 563 "Viewer.c"
				}
#line 66 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 567 "Viewer.c"
			}
		}
	}
#line 69 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (!trying_global) {
#line 573 "Viewer.c"
		const gchar* _tmp10_;
		ENotesServicesSettings* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		ENotesNotebookTable* _tmp16_;
		ENotesNotebookTable* _tmp17_;
		ENotesPage* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp10_ = self->CSS;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp11_ = enotes_settings;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp12_ = enotes_services_settings_get_render_stylesheet (_tmp11_);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp13_ = _tmp12_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp15_ = _tmp14_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp16_ = enotes_notebook_table_get_instance ();
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp17_ = _tmp16_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp18_ = self->priv->previous_page;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp19_ = enotes_notebook_table_get_css_from_page (_tmp17_, _tmp18_->id);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp20_ = _tmp19_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp21_ = g_strconcat (_tmp15_, _tmp20_, NULL);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (self->CSS);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		self->CSS = _tmp21_;
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (_tmp20_);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_database_table_unref0 (_tmp17_);
#line 70 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (_tmp15_);
#line 620 "Viewer.c"
	}
}

void
enotes_viewer_reload (ENotesViewer* self)
{
	ENotesPage* _tmp0_;
#line 74 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 75 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = self->priv->previous_page;
#line 75 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp0_ != NULL) {
#line 634 "Viewer.c"
		ENotesPage* _tmp1_;
		ENotesPage* _tmp2_;
#line 76 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = self->priv->previous_page;
#line 76 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		enotes_viewer_load_css (self, _tmp1_, TRUE);
#line 77 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp2_ = self->priv->previous_page;
#line 77 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		enotes_viewer_load_page (self, _tmp2_, TRUE);
#line 645 "Viewer.c"
	}
}

static gboolean
_enotes_mode_equal (const ENotesMode * s1,
                    const ENotesMode * s2)
{
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (s1 == s2) {
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		return TRUE;
#line 657 "Viewer.c"
	}
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (s1 == NULL) {
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		return FALSE;
#line 663 "Viewer.c"
	}
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (s2 == NULL) {
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		return FALSE;
#line 669 "Viewer.c"
	}
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return (*s1) == (*s2);
#line 673 "Viewer.c"
}

void
enotes_viewer_load_page (ENotesViewer* self,
                         ENotesPage* page,
                         gboolean force_load)
{
	gboolean _tmp0_ = FALSE;
	ENotesMode* _tmp1_;
	ENotesMode* _tmp2_;
	ENotesMode _tmp3_;
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 81 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (page != NULL);
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp1_ = enotes_view_edit_stack_get_current_mode ();
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = _tmp1_;
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = ENOTES_MODE_VIEW;
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_enotes_mode_equal (_tmp2_, &_tmp3_) == TRUE) {
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp0_ = TRUE;
#line 699 "Viewer.c"
	} else {
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp0_ = force_load;
#line 703 "Viewer.c"
	}
#line 82 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp0_) {
#line 707 "Viewer.c"
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
		const gchar* _tmp15_;
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp5_ = page->html_cache;
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (g_strcmp0 (_tmp5_, "") == 0) {
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp4_ = TRUE;
#line 717 "Viewer.c"
		} else {
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp4_ = force_load;
#line 721 "Viewer.c"
		}
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (_tmp4_) {
#line 725 "Viewer.c"
			gchar* markdown = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			gchar** _tmp9_;
			gchar** _tmp10_;
			gint _tmp10__length1;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			ENotesPageTable* _tmp13_;
			ENotesPageTable* _tmp14_;
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp6_ = page->data;
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp9_ = enotes_viewer_process_frontmatter (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (markdown);
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			markdown = _tmp7_;
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp10_ = _tmp9_;
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp10__length1 = _tmp8_;
#line 85 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 86 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			enotes_viewer_load_css (self, page, FALSE);
#line 87 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp11_ = markdown;
#line 87 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp12_ = enotes_viewer_process (self, _tmp11_);
#line 87 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (page->html_cache);
#line 87 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			page->html_cache = _tmp12_;
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp13_ = enotes_page_table_get_instance ();
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp14_ = _tmp13_;
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			enotes_page_table_save_cache (_tmp14_, page);
#line 89 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_database_table_unref0 (_tmp14_);
#line 83 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (markdown);
#line 771 "Viewer.c"
		}
#line 92 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp15_ = page->html_cache;
#line 92 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		webkit_web_view_load_html ((WebKitWebView*) self, _tmp15_, "file:///");
#line 777 "Viewer.c"
	}
}

static GtkWidget*
__lambda21_ (ENotesViewer* self,
             WebKitNavigationAction* navigation_action)
{
	WebKitURIRequest* _tmp0_;
	const gchar* _tmp1_;
	GtkWidget* result;
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (navigation_action != NULL, NULL);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = webkit_navigation_action_get_request (navigation_action);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp1_ = webkit_uri_request_get_uri (_tmp0_);
#line 98 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	enotes_viewer_launch_browser (self, _tmp1_);
#line 99 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = NULL;
#line 99 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 800 "Viewer.c"
}

static GtkWidget*
___lambda21__webkit_web_view_create (WebKitWebView* _sender,
                                     WebKitNavigationAction* navigation_action,
                                     gpointer self)
{
	GtkWidget* result;
	result = __lambda21_ ((ENotesViewer*) self, navigation_action);
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 812 "Viewer.c"
}

static gboolean
__lambda22_ (ENotesViewer* self,
             WebKitPolicyDecision* decision,
             WebKitPolicyDecisionType type)
{
	gboolean result;
#line 102 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (decision != NULL, FALSE);
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	switch (type) {
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		case WEBKIT_POLICY_DECISION_TYPE_NEW_WINDOW_ACTION:
#line 827 "Viewer.c"
		{
#line 105 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (decision, webkit_response_policy_decision_get_type ())) {
#line 831 "Viewer.c"
				WebKitURIRequest* _tmp0_;
				WebKitURIRequest* _tmp1_;
				const gchar* _tmp2_;
#line 106 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp0_ = webkit_response_policy_decision_get_request (G_TYPE_CHECK_INSTANCE_TYPE (decision, webkit_response_policy_decision_get_type ()) ? ((WebKitResponsePolicyDecision*) decision) : NULL);
#line 106 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp1_ = _tmp0_;
#line 106 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp2_ = webkit_uri_request_get_uri (_tmp1_);
#line 106 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				enotes_viewer_launch_browser (self, _tmp2_);
#line 843 "Viewer.c"
			}
#line 108 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			break;
#line 847 "Viewer.c"
		}
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		case WEBKIT_POLICY_DECISION_TYPE_RESPONSE:
#line 851 "Viewer.c"
		{
#line 110 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (decision, webkit_response_policy_decision_get_type ())) {
#line 855 "Viewer.c"
				WebKitResponsePolicyDecision* policy = NULL;
				WebKitResponsePolicyDecision* _tmp3_;
				WebKitResponsePolicyDecision* _tmp4_;
				WebKitURIRequest* _tmp5_;
				WebKitURIRequest* _tmp6_;
				const gchar* _tmp7_;
#line 111 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (decision, webkit_response_policy_decision_get_type (), WebKitResponsePolicyDecision));
#line 111 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				policy = _tmp3_;
#line 112 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp4_ = policy;
#line 112 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp5_ = webkit_response_policy_decision_get_request (_tmp4_);
#line 112 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp6_ = _tmp5_;
#line 112 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp7_ = webkit_uri_request_get_uri (_tmp6_);
#line 112 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				enotes_viewer_launch_browser (self, _tmp7_);
#line 113 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				result = FALSE;
#line 113 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_object_unref0 (policy);
#line 113 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				return result;
#line 882 "Viewer.c"
			}
#line 115 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			break;
#line 886 "Viewer.c"
		}
		default:
#line 103 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		break;
#line 891 "Viewer.c"
	}
#line 118 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = TRUE;
#line 118 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 897 "Viewer.c"
}

static gboolean
___lambda22__webkit_web_view_decide_policy (WebKitWebView* _sender,
                                            WebKitPolicyDecision* decision,
                                            WebKitPolicyDecisionType type,
                                            gpointer self)
{
	gboolean result;
	result = __lambda22_ ((ENotesViewer*) self, decision, type);
#line 102 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 910 "Viewer.c"
}

static void
__lambda23_ (ENotesViewer* self,
             WebKitLoadEvent event)
{
#line 122 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (event == WEBKIT_LOAD_FINISHED) {
#line 919 "Viewer.c"
		GdkRectangle rectangle = {0};
		WebKitWindowProperties* _tmp0_;
		GdkRectangle _tmp1_ = {0};
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
#line 123 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp0_ = webkit_web_view_get_window_properties ((WebKitWebView*) self);
#line 123 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		webkit_window_properties_get_geometry (_tmp0_, &_tmp1_);
#line 123 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		rectangle = _tmp1_;
#line 124 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp2_ = rectangle;
#line 124 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp3_ = rectangle;
#line 124 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp2_.width, _tmp3_.height);
#line 937 "Viewer.c"
	}
}

static void
___lambda23__webkit_web_view_load_changed (WebKitWebView* _sender,
                                           WebKitLoadEvent load_event,
                                           gpointer self)
{
#line 121 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	__lambda23_ ((ENotesViewer*) self, load_event);
#line 948 "Viewer.c"
}

static void
enotes_viewer_connect_signals (ENotesViewer* self)
{
#line 96 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 97 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_signal_connect_object ((WebKitWebView*) self, "create", (GCallback) ___lambda21__webkit_web_view_create, self, 0);
#line 102 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_signal_connect_object ((WebKitWebView*) self, "decide-policy", (GCallback) ___lambda22__webkit_web_view_decide_policy, self, 0);
#line 121 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_signal_connect_object ((WebKitWebView*) self, "load-changed", (GCallback) ___lambda23__webkit_web_view_load_changed, self, 0);
#line 962 "Viewer.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 981 "Viewer.c"
}

static void
enotes_viewer_launch_browser (ENotesViewer* self,
                              const gchar* url)
{
	GError* _inner_error0_ = NULL;
#line 129 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (self != NULL);
#line 129 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_if_fail (url != NULL);
#line 130 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (!string_contains (url, "/embed/")) {
#line 995 "Viewer.c"
		{
#line 132 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			g_app_info_launch_default_for_uri (url, NULL, &_inner_error0_);
#line 132 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1001 "Viewer.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp0_;
			const gchar* _tmp1_;
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			e = _inner_error0_;
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_inner_error0_ = NULL;
#line 134 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp0_ = e;
#line 134 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp1_ = _tmp0_->message;
#line 134 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			g_warning ("Viewer.vala:134: No app to handle urls: %s", _tmp1_);
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_error_free0 (e);
#line 1023 "Viewer.c"
		}
		__finally0:
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			g_clear_error (&_inner_error0_);
#line 131 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			return;
#line 1034 "Viewer.c"
		}
#line 136 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		webkit_web_view_stop_loading ((WebKitWebView*) self);
#line 1038 "Viewer.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 1066 "Viewer.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 1072 "Viewer.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1078 "Viewer.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1082 "Viewer.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1090 "Viewer.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1094 "Viewer.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 1106 "Viewer.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1128 "Viewer.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 1136 "Viewer.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 1142 "Viewer.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if ((*length) == (*size)) {
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1158 "Viewer.c"
	}
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	(*array)[(*length)++] = value;
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	(*array)[*length] = NULL;
#line 1164 "Viewer.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if ((*length) == (*size)) {
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1179 "Viewer.c"
	}
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	(*array)[(*length)++] = value;
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	(*array)[*length] = NULL;
#line 1185 "Viewer.c"
}

static gchar**
enotes_viewer_process_frontmatter (ENotesViewer* self,
                                   const gchar* raw_mk,
                                   gchar** processed_mk,
                                   gint* result_length1)
{
	gchar* _vala_processed_mk = NULL;
	gchar** map = NULL;
	gchar** _tmp0_;
	gint map_length1;
	gint _map_size_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp21_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar** result;
#line 140 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (raw_mk != NULL, NULL);
#line 141 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 141 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	map = _tmp0_;
#line 141 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	map_length1 = 0;
#line 141 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_map_size_ = map_length1;
#line 143 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_vala_processed_mk);
#line 143 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_vala_processed_mk = NULL;
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = strlen (raw_mk);
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = _tmp2_;
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp3_ > 4) {
#line 1228 "Viewer.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp4_ = string_slice (raw_mk, (glong) 0, (glong) 4);
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp5_ = _tmp4_;
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = g_strcmp0 (_tmp5_, "---\n") == 0;
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (_tmp5_);
#line 1239 "Viewer.c"
	} else {
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp1_ = FALSE;
#line 1243 "Viewer.c"
	}
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp1_) {
#line 1247 "Viewer.c"
		gint i = 0;
		gboolean valid_frontmatter = FALSE;
		gint last_newline = 0;
		gint next_newline = 0;
		gchar* line = NULL;
		gchar* _tmp6_;
#line 147 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		i = 0;
#line 148 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		valid_frontmatter = TRUE;
#line 149 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		last_newline = 3;
#line 151 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp6_ = g_strdup ("");
#line 151 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		line = _tmp6_;
#line 152 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		while (TRUE) {
#line 1266 "Viewer.c"
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gint sep_index = 0;
			const gchar* _tmp9_;
			gint _tmp17_;
#line 154 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			next_newline = string_index_of_char (raw_mk, (gunichar) '\n', last_newline + 1);
#line 155 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (next_newline == -1) {
#line 156 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				valid_frontmatter = FALSE;
#line 157 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 1280 "Viewer.c"
			}
#line 160 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp7_ = string_slice (raw_mk, (glong) (last_newline + 1), (glong) next_newline);
#line 160 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (line);
#line 160 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			line = _tmp7_;
#line 161 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			last_newline = next_newline;
#line 163 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp8_ = line;
#line 163 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (g_strcmp0 (_tmp8_, "---") == 0) {
#line 164 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 1296 "Viewer.c"
			}
#line 167 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp9_ = line;
#line 167 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			sep_index = string_index_of_char (_tmp9_, (gunichar) ':', 0);
#line 168 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			if (sep_index != -1) {
#line 1304 "Viewer.c"
				const gchar* _tmp10_;
				gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gchar* _tmp16_;
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp10_ = line;
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp11_ = string_slice (_tmp10_, (glong) 0, (glong) (sep_index - 1));
#line 169 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_vala_array_add1 (&map, &map_length1, &_map_size_, _tmp11_);
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp12_ = line;
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp13_ = line;
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp14_ = strlen (_tmp13_);
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp15_ = _tmp14_;
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp16_ = string_slice (_tmp12_, (glong) (sep_index + 1), (glong) _tmp15_);
#line 170 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_vala_array_add2 (&map, &map_length1, &_map_size_, _tmp16_);
#line 1330 "Viewer.c"
			} else {
#line 172 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				valid_frontmatter = FALSE;
#line 173 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				break;
#line 1336 "Viewer.c"
			}
#line 176 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp17_ = i;
#line 176 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			i = _tmp17_ + 1;
#line 1342 "Viewer.c"
		}
#line 179 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		if (valid_frontmatter) {
#line 1346 "Viewer.c"
			gint _tmp18_;
			gint _tmp19_;
			gchar* _tmp20_;
#line 180 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp18_ = strlen (raw_mk);
#line 180 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp19_ = _tmp18_;
#line 180 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp20_ = string_slice (raw_mk, (glong) last_newline, (glong) _tmp19_);
#line 180 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_g_free0 (_vala_processed_mk);
#line 180 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_vala_processed_mk = _tmp20_;
#line 1360 "Viewer.c"
		}
#line 146 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (line);
#line 1364 "Viewer.c"
	}
#line 184 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp21_ = _vala_processed_mk;
#line 184 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (_tmp21_ == NULL) {
#line 1370 "Viewer.c"
		gchar* _tmp22_;
#line 185 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_tmp22_ = g_strdup (raw_mk);
#line 185 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (_vala_processed_mk);
#line 185 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_vala_processed_mk = _tmp22_;
#line 1378 "Viewer.c"
	}
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp23_ = map;
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp23__length1 = map_length1;
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (result_length1) {
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*result_length1 = _tmp23__length1;
#line 1388 "Viewer.c"
	}
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = _tmp23_;
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	if (processed_mk) {
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		*processed_mk = _vala_processed_mk;
#line 1396 "Viewer.c"
	} else {
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		_g_free0 (_vala_processed_mk);
#line 1400 "Viewer.c"
	}
#line 188 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 1404 "Viewer.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1566 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1567 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1567 "glib-2.0.vapi"
	res_length1 = -1;
#line 1567 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1568 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1568 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1568 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1569 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1569 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1569 "glib-2.0.vapi"
	if (result_length1) {
#line 1569 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1441 "Viewer.c"
	}
#line 1569 "glib-2.0.vapi"
	result = _tmp2_;
#line 1569 "glib-2.0.vapi"
	return result;
#line 1447 "Viewer.c"
}

static gchar*
enotes_viewer_process (ENotesViewer* self,
                       const gchar* raw_mk)
{
	gchar* processed_mk = NULL;
	gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	MMIOT* mkd = NULL;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	MMIOT* _tmp7_;
	gchar* _result_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* html = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* result;
#line 191 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (raw_mk != NULL, NULL);
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = enotes_viewer_process_frontmatter (self, raw_mk, &_tmp0_, &_tmp1_);
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (processed_mk);
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	processed_mk = _tmp0_;
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = _tmp2_;
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3__length1 = _tmp1_;
#line 193 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_ = string_get_data (processed_mk, &_tmp5_);
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4__length1 = _tmp5_;
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp6_ = _tmp4_;
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp6__length1 = _tmp4__length1;
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp7_ = mkd_string (_tmp6_, _tmp6__length1, ((((0x00200000 + 0x00004000) + 0x02000000) + 0x01000000) + 0x00400000) + 0x40000000);
#line 195 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	mkd = _tmp7_;
#line 196 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	mkd_compile (mkd, ((((0x00200000 + 0x00004000) + 0x02000000) + 0x01000000) + 0x00400000) + 0x40000000);
#line 199 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	mkd_document (mkd, &_tmp8_);
#line 199 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_result_);
#line 199 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 199 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_result_ = _tmp9_;
#line 201 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp10_ = g_strdup ("<!doctype html><meta charset=utf-8><head>");
#line 201 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	html = _tmp10_;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp11_ = html;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp12_ = self->CSS;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp13_ = g_strconcat ("<style>", _tmp12_, NULL);
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp14_ = _tmp13_;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp15_ = g_strconcat (_tmp14_, "</style>", NULL);
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp16_ = _tmp15_;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp17_ = g_strconcat (_tmp11_, _tmp16_, NULL);
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (html);
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	html = _tmp17_;
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_tmp16_);
#line 202 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_tmp14_);
#line 203 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp18_ = html;
#line 203 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp19_ = g_strconcat (_tmp18_, "</head><body><div class=\"markdown-body\">", NULL);
#line 203 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (html);
#line 203 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	html = _tmp19_;
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp20_ = html;
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp21_ = enotes_viewer_process_plugins (self, _result_);
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp22_ = _tmp21_;
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp23_ = g_strconcat (_tmp20_, _tmp22_, NULL);
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (html);
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	html = _tmp23_;
#line 204 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_tmp22_);
#line 205 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp24_ = html;
#line 205 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp25_ = g_strconcat (_tmp24_, "</div></body></html>", NULL);
#line 205 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (html);
#line 205 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	html = _tmp25_;
#line 207 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = html;
#line 207 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (_result_);
#line 207 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_mkd_cleanup0 (mkd);
#line 207 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (processed_mk);
#line 207 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 1592 "Viewer.c"
}

static gchar*
enotes_viewer_process_plugins (ENotesViewer* self,
                               const gchar* raw_mk)
{
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	gchar* build = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result;
#line 210 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_return_val_if_fail (raw_mk != NULL, NULL);
#line 211 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp1_ = _tmp0_ = g_strsplit (raw_mk, "\n", 0);
#line 211 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	lines = _tmp1_;
#line 211 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	lines_length1 = _vala_array_length (_tmp0_);
#line 211 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_lines_size_ = lines_length1;
#line 212 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = g_strdup ("");
#line 212 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	build = _tmp2_;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = lines;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3__length1 = lines_length1;
#line 1629 "Viewer.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		line_collection = _tmp3_;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		line_collection_length1 = _tmp3__length1;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1641 "Viewer.c"
			gchar* _tmp4_;
			gchar* line = NULL;
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			_tmp4_ = g_strdup (line_collection[line_it]);
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
			line = _tmp4_;
#line 1648 "Viewer.c"
			{
				gboolean found = FALSE;
				ENotesPluginManager* _tmp5_;
				ENotesPluginManager* _tmp6_;
				gint _tmp7_ = 0;
				ENotesPlugin** _tmp8_;
				ENotesPlugin** _tmp9_;
				gint _tmp9__length1;
#line 214 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				found = FALSE;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp5_ = enotes_plugin_manager_get_instance ();
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp6_ = _tmp5_;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp8_ = enotes_plugin_manager_get_plugs (_tmp6_, &_tmp7_);
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp9_ = _tmp8_;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_tmp9__length1 = _tmp7_;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_object_unref0 (_tmp6_);
#line 1671 "Viewer.c"
				{
					ENotesPlugin** plugin_collection = NULL;
					gint plugin_collection_length1 = 0;
					gint _plugin_collection_size_ = 0;
					gint plugin_it = 0;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					plugin_collection = _tmp9_;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					plugin_collection_length1 = _tmp9__length1;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					for (plugin_it = 0; plugin_it < plugin_collection_length1; plugin_it = plugin_it + 1) {
#line 1683 "Viewer.c"
						ENotesPlugin* _tmp10_;
						ENotesPlugin* plugin = NULL;
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
						_tmp10_ = _g_object_ref0 (plugin_collection[plugin_it]);
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
						plugin = _tmp10_;
#line 1690 "Viewer.c"
						{
							ENotesPlugin* _tmp11_;
							const gchar* _tmp12_;
#line 216 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
							_tmp11_ = plugin;
#line 216 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
							_tmp12_ = line;
#line 216 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
							if (enotes_plugin_has_match (_tmp11_, _tmp12_)) {
#line 1700 "Viewer.c"
								const gchar* _tmp13_;
								ENotesPlugin* _tmp14_;
								const gchar* _tmp15_;
								gchar* _tmp16_;
								gchar* _tmp17_;
								gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp13_ = build;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp14_ = plugin;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp15_ = line;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp16_ = enotes_plugin_convert (_tmp14_, _tmp15_);
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp17_ = _tmp16_;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp18_ = g_strconcat (_tmp13_, _tmp17_, NULL);
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp19_ = _tmp18_;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_tmp20_ = g_strconcat (_tmp19_, "\n", NULL);
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_g_free0 (build);
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								build = _tmp20_;
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_g_free0 (_tmp19_);
#line 217 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_g_free0 (_tmp17_);
#line 218 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								found = TRUE;
#line 219 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								_g_object_unref0 (plugin);
#line 219 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
								break;
#line 1739 "Viewer.c"
							}
#line 215 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
							_g_object_unref0 (plugin);
#line 1743 "Viewer.c"
						}
					}
				}
#line 223 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				if (!found) {
#line 1749 "Viewer.c"
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp21_ = build;
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp22_ = line;
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp24_ = _tmp23_;
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_tmp25_ = g_strconcat (_tmp24_, "\n", NULL);
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_g_free0 (build);
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					build = _tmp25_;
#line 224 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
					_g_free0 (_tmp24_);
#line 1771 "Viewer.c"
				}
#line 213 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
				_g_free0 (line);
#line 1775 "Viewer.c"
			}
		}
	}
#line 228 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	result = build;
#line 228 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 228 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	return result;
#line 1785 "Viewer.c"
}

static void
enotes_viewer_class_init (ENotesViewerClass * klass,
                          gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	enotes_viewer_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	g_type_class_adjust_private_offset (klass, &ENotesViewer_private_offset);
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	G_OBJECT_CLASS (klass)->finalize = enotes_viewer_finalize;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp0_ = g_strdup (_ ("Default"));
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp1_ = g_strdup ("elementary");
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp2_ = g_strdup (_ ("Air"));
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp3_ = g_strdup (_ ("Modest"));
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_[0] = _tmp0_;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_[1] = _tmp1_;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_[2] = _tmp2_;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_tmp4_[3] = _tmp3_;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	enotes_viewer_STYLES = _tmp4_;
#line 23 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	enotes_viewer_STYLES_length1 = 4;
#line 1825 "Viewer.c"
}

static void
enotes_viewer_instance_init (ENotesViewer * self,
                             gpointer klass)
{
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	self->priv = enotes_viewer_get_instance_private (self);
#line 28 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	self->priv->previous_page = NULL;
#line 1836 "Viewer.c"
}

static void
enotes_viewer_finalize (GObject * obj)
{
	ENotesViewer * self;
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ENOTES_TYPE_VIEWER, ENotesViewer);
#line 27 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_free0 (self->CSS);
#line 28 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	_g_object_unref0 (self->priv->previous_page);
#line 22 "/home/abuild/rpmbuild/BUILD/Notes-up-1.5.2/src/Widgets/Viewer.vala"
	G_OBJECT_CLASS (enotes_viewer_parent_class)->finalize (obj);
#line 1851 "Viewer.c"
}

static GType
enotes_viewer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ENotesViewerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) enotes_viewer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ENotesViewer), 0, (GInstanceInitFunc) enotes_viewer_instance_init, NULL };
	GType enotes_viewer_type_id;
	enotes_viewer_type_id = g_type_register_static (webkit_web_view_get_type (), "ENotesViewer", &g_define_type_info, 0);
	ENotesViewer_private_offset = g_type_add_instance_private (enotes_viewer_type_id, sizeof (ENotesViewerPrivate));
	return enotes_viewer_type_id;
}

GType
enotes_viewer_get_type (void)
{
	static volatile gsize enotes_viewer_type_id__once = 0;
	if (g_once_init_enter (&enotes_viewer_type_id__once)) {
		GType enotes_viewer_type_id;
		enotes_viewer_type_id = enotes_viewer_get_type_once ();
		g_once_init_leave (&enotes_viewer_type_id__once, enotes_viewer_type_id);
	}
	return enotes_viewer_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

